(function(_){
  var browserRequest, serverRequest, request;
  browserRequest = function(){
    var jQuery, ajax, get, post;
    jQuery = typeof jQuery === 'undefined' ? null : jQuery;
    ajax = jQuery
      ? jQuery.ajax
      : function(options){
        var d, XHR, xhr;
        d = _.Deferred();
        XHR = window.ActiveXObject || XMLHttpRequest;
        xhr = new XHR('Microsoft.XMLHTTP');
        xhr.open(options.type || (options.data ? 'POST' : 'GET'), options.url, true);
        if (in$('overrideMimeType', xhr)) {
          xhr.overrideMimeType(options.dataType || 'text/plain');
        }
        xhr.onreadystatechange = function(){
          var _ref, resolution;
          if (deepEq$(xhr.readyState, 4, '===')) {
            if (deepEq$(_ref = xhr.status, 0, '===') || deepEq$(_ref, 200, '===')) {
              resolution = xhr.responseText;
              if (options.dataType === "application/json") {
                resolution = JSON.parse(resolution);
              }
              d.resolve(resolution);
            } else {
              d.reject(new Error("Could not load " + options.url));
            }
            return;
          }
          return d.notify(xhr);
        };
        if (options.data) {
          xhr.setRequestHeader("Content-type", options.dataType || "application/x-www-form-urlencoded");
        }
        xhr.send(options.data || null);
        return d.promise();
      };
    get = jQuery
      ? jQuery.get
      : function(url, options){
        options = options || {};
        options.url = url;
        options.type = 'GET';
        options.data = null;
        return ajax(options);
      };
    post = jQuery
      ? jQuery.post
      : function(url, options){
        options = options || {};
        options.url = url;
        options.type = 'POST';
        return ajax(options);
      };
    return {
      get: get,
      post: post
    };
  };
  serverRequest = function(){
    var request, get, post;
    request = require('request');
    get = function(uri){
      var d;
      d = _.Deferred();
      request.get(uri, function(err, success, body){
        return d.resolve(body);
      });
      return d.promise();
    };
    post = function(uri, options){
      var d;
      d = _.Deferred();
      if (options.data) {
        options.body = options.data.toString();
        delete options.data;
      }
      if (options.dataType) {
        (options.headers || (options.headers = {}))["Content-type"] = options.dataType;
        delete options.dataType;
      }
      request.post(uri, options, function(err, success, body){
        return d.resolve(body);
      });
      return d.promise();
    };
    return {
      get: get,
      post: post
    };
  };
  if (typeof window !== 'undefined') {
    request = browserRequest();
  } else {
    request = serverRequest();
  }
  _.request = function(uri){
    var d;
    d = _.Deferred();
    if (uri === "") {
      setTimeout(function(){
        return d.resolve("");
      }, 0);
    } else {
      _.request.get(uri).then(function(it){
        return d.resolve(it);
      });
    }
    return d.promise();
  };
  import$(_.request, request);
}.call(this, underscore));
function in$(x, arr){
  var i = -1, l = arr.length >>> 0;
  while (++i < l) if (x === arr[i] && i in arr) return true;
  return false;
}
function deepEq$(x, y, type){
  var toString = {}.toString, hasOwnProperty = {}.hasOwnProperty,
      has = function (obj, key) { return hasOwnProperty.call(obj, key); };
  first = true;
  return eq(x, y, []);
  function eq(a, b, stack) {
    var className, length, size, result, alength, blength, r, key, ref, sizeB;
    if (a == null || b == null) { return a === b; }
    if (a.__placeholder__ || b.__placeholder__) { return true; }
    if (a === b) { return a !== 0 || 1 / a == 1 / b; }
    className = toString.call(a);
    if (toString.call(b) != className) { return false; }
    switch (className) {
      case '[object String]': return a == String(b);
      case '[object Number]':
        return a != +a ? b != +b : (a == 0 ? 1 / a == 1 / b : a == +b);
      case '[object Date]':
      case '[object Boolean]':
        return +a == +b;
      case '[object RegExp]':
        return a.source == b.source &&
               a.global == b.global &&
               a.multiline == b.multiline &&
               a.ignoreCase == b.ignoreCase;
    }
    if (typeof a != 'object' || typeof b != 'object') { return false; }
    length = stack.length;
    while (length--) { if (stack[length] == a) { return true; } }
    stack.push(a);
    size = 0;
    result = true;
    if (className == '[object Array]') {
      alength = a.length;
      blength = b.length;
      if (first) { 
        switch (type) {
        case '===': result = alength === blength; break;
        case '<==': result = alength <= blength; break;
        case '<<=': result = alength < blength; break;
        }
        size = alength;
        first = false;
      } else {
        result = alength === blength;
        size = alength;
      }
      if (result) {
        while (size--) {
          if (!(result = size in a == size in b && eq(a[size], b[size], stack))){ break; }
        }
      }
    } else {
      if ('constructor' in a != 'constructor' in b || a.constructor != b.constructor) {
        return false;
      }
      for (key in a) {
        if (has(a, key)) {
          size++;
          if (!(result = has(b, key) && eq(a[key], b[key], stack))) { break; }
        }
      }
      if (result) {
        sizeB = 0;
        for (key in b) {
          if (has(b, key)) { ++sizeB; }
        }
        if (first) {
          if (type === '<<=') {
            result = size < sizeB;
          } else if (type === '<==') {
            result = size <= sizeB
          } else {
            result = size === sizeB;
          }
        } else {
          first = false;
          result = size === sizeB;
        }
      }
    }
    stack.pop();
    return result;
  }
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}